#include "Gra.ch"
#include "Xbp.ch"
#include "AppEvent.ch"

Static nColorNum := 0

Procedure Main()
  Local nEvent := 0
  Local oDlg

  aPP := { { XBP_PP_BGCLR , GRA_CLR_RED  } }

  oDlg := xbpDialog():New(,,,{350,350})
  oDlg:MaxButton := .F.
  oDlg:MinButton := .F.
  oDlg:TaskList := .T.
  oDlg:Title := "Drawing Class Test"
  oDlg:Create()

  oPS := oDlg:DrawingArea

  oDlg2 := xbpDrawStatic():New(oPS,,{0,40},{350,280},aPP)
  oDlg2:SetFGC(GraMakeRGBColor({0,0,0}))
  oDlg2:SetBGC(GraMakeRGBColor({255,255,255}))
  oDlg2:Create()

  oXbp := XbpPushButton():new(oPS,,{0,0},{35,35})
  oXbp:caption := "PEN"
  oXbp:create()
  oXbp:activate:= {|| oDlg2:SetTool(1) }

  oXbp := XbpPushButton():new(oPS,,{35,0},{35,35})
  oXbp:caption := "LIN"
  oXbp:create()
  oXbp:activate:= {|| oDlg2:SetTool(2) }

  oXbp := XbpPushButton():new(oPS,,{70,0},{35,35})
  oXbp:caption := "CIR"
  oXbp:create()
  oXbp:activate:= {|| oDlg2:SetTool(3) }

  oXbp := XbpPushButton():new(oPS,,{105,0},{35,35})
  oXbp:caption := "SQR"
  oXbp:create()
  oXbp:activate:= {|| oDlg2:SetTool(4) }

  oXbp := XbpPushButton():new(oPS,,{140,0},{35,35})
  oXbp:caption := "UnDo"
  oXbp:create()
  oXbp:activate:= {|| UndoMe(oDlg2) }

  oXbp3 := XbpStatic():new(oPS,,{210,0},{35,35})
  oXbp3:Create()

  oXbp2 := XbpPushButton():new(oPS,,{175,0},{35,35})
  oXbp2:caption := "Color"
  oXbp2:create()
  oXbp2:activate:= {|| ChgColor(oXbp3,oDlg2,oPS) }

  oXbp22 := XbpStatic():new(oPS,,{245,0},{35,35})
  oXbp22:Caption := AllTrim(Str(oDlg2:SetPenSize()))
  oXbp22:Create()

  oSpin := XbpSpinButton():New(oPS,,{280,0},{15,35})
  oSpin:Down := {|mp1,mp2,oXbp| CursDown(oXbp22,oDlg2,oSpin:GetData()) }
  oSpin:Up   := {|mp1,mp2,oXbp| CursUp(oXbp22,oDlg2,oSpin:GetData())   }
  oSpin:Create()
  oSpin:SetNumLimits(0,25)
  oSpin:SetData(oDlg2:SetPenSize())


  ChgColor(oXbp3,oDlg2,oPS)

  Do While nEvent <> xbeP_Close
    nEvent := AppEvent( @mp1, @mp2, @oXbp )
    oXbp:HandleEvent( nEvent, mp1, mp2 )
  EndDo

  Return

  // do not show the dos prompt
Procedure AppSys()
Return

Procedure ChgColor(oPart,oDraw,oPS)
  Local aColors := {GRA_CLR_BLACK      ,;
                    GRA_CLR_BLUE       ,;
                    GRA_CLR_RED        ,;
                    GRA_CLR_PINK       ,;
                    GRA_CLR_GREEN      ,;
                    GRA_CLR_CYAN       ,;
                    GRA_CLR_YELLOW     ,;
                    GRA_CLR_WHITE      ,;
                    GRA_CLR_DARKGRAY   ,;
                    GRA_CLR_DARKBLUE   ,;
                    GRA_CLR_DARKRED    ,;
                    GRA_CLR_DARKPINK   ,;
                    GRA_CLR_DARKGREEN  ,;
                    GRA_CLR_DARKCYAN   ,;
                    GRA_CLR_BROWN      ,;
                    GRA_CLR_PALEGRAY   }
  Local aPP := { { XBP_PP_BGCLR , GRA_CLR_RED  } }

  If nColorNum == Len(aColors)
    nColorNum := 0
  EndIf

  nColorNum++

  aPP[1][2] := aColors[nColorNum]

  oPart:Configure(oPS,,{210,0},{35,35},aPP)

  oDraw:SetFGC(aColors[nColorNum])

Return

Function CursDown(oXbp,oDraw,nVal)
  oXbp:SetCaption(AllTrim(str(nVal)))
  oDraw:SetPenSize(nVal)
Return

Function CursUp(oXbp,oDraw,nVal)
  oXbp:SetCaption(AllTrim(str(nVal)))
  oDraw:SetPenSize(nVal)
Return

Procedure UndoMe(oDlg2)
  // actually undo it
  If oDlg2:CanUndo()
    oDlg2:UndoLast()
  Else
    MsgBox("Cannot Undo!")
  EndIf

  Return
